<?php
/****************************************************************************\
 *  Plugin Statistiques pour les brves                          	      	  *
 *  Copyright (c) 2007-2009                                                 *
 *  Elrik - Peetdu - Mathieu Carrandi                                      *
 *                                                                          *
 *  Bas sur ecrire/exec/statistiques_visites.php et adapt pour les brves *
 *                                                                          *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.      *
\****************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/statistiques');

// bas sur http://doc.spip.org/@exec_statistiques_visites_dist
// modif pour breves
function exec_stats_breves_detail()
{
	$id_breve = intval(_request('id_breve'));
	$type = _request('type');
	if (!preg_match('/^\w+$/', $type)) $type = 'day';
	$duree = intval(_request('duree'));
	if (!$duree) $duree = 105;
	$interval = intval(_request('interval'));
	if (!$interval) {
	  if ($type == 'day')
	    $interval = 3600*24;
	  else $interval = 3600;
	}

	// nombre de referers a afficher
	$limit = intval(_request('limit'));
	if ($limit == 0) $limit = 100;

	if (!autoriser('voirstats', $id_breve ? 'breve':'', $id_breve)) {
		include_spip('inc/minipres');
		echo minipres();
	} else exec_stats_breves_detail_args($id_breve, $duree, $interval, $type, $limit);
}

// bas sur http://doc.spip.org/@exec_statistiques_visites_args
// modif pour breves
function exec_stats_breves_detail_args($id_breve, $duree, $interval, $type, $limit,$serveur='')
{
	$titre = $pourbreve = "";

	if ($id_breve){
		$row = sql_fetsel("titre, visites", "spip_breves", "statut='publie' AND id_breve=$id_breve",'','','','',$serveur);

		if ($row) {
			$titre = typo($row['titre']);
			$total_absolu = $row['visites'];
		}
	} else {
		$row = sql_fetsel("SUM(visites) AS total_absolu", "spip_visites",'','','','','',$serveur);
		$total_absolu = $row ? $row['total_absolu'] : 0;
		$val_popularite = 0;
	}

	if ($titre) $pourbreve = " "._T('info_pour')." &laquo; $titre &raquo;";
	if ($serveur) {
		if ($row = sql_fetsel('valeur','spip_meta',"nom='nom_site'",'','','','',$serveur)){
			$titre = $row['valeur'].($titre?" / $titre":"");
		}
	}

	$commencer_page = charger_fonction('commencer_page', 'inc');
	echo $commencer_page(_T('titre_page_statistiques_visites').$pourbreve, "statistiques_visites", "statistiques");
	echo gros_titre(_T('titre_evolution_visite'),'', false);
//	barre_onglets("statistiques", "evolution");
  if ($titre) echo gros_titre($titre,'', false);

	echo debut_gauche('', true);
	echo "<br />";
	echo "<div class='iconeoff' style='padding: 5px;'>";
	echo "<div class='verdana1 spip_x-small'>";

	echo typo(_T('info_afficher_visites'));
	echo "<ul>";

  echo "<li><b><a href='" . generer_url_ecrire("statistiques_visites","") . "'>"._T('info_tout_site')."</a></b></li>";
	if ($id_breve>0) echo "<li><b><a href='" . generer_url_ecrire("stats_breves_tableau","") . "'>"._T('stbrv:info_toutes_breves')."</a></b></li>";
    echo "</ul>";
    echo "</div>";
    echo "</div>";

	// Par visites depuis le debut
	$result = aff_statistique_breves_par_visites($serveur, $id_article);
	echo $result;

	if ($result OR $id_breve)
		echo creer_colonne_droite('', true);

	if ($id_breve) {
		echo bloc_des_raccourcis(icone_horizontale(_T('stbrv:icone_retour_breve'), generer_url_ecrire("breves_voir","id_breve=$id_breve"), "breve-24.gif","rien.gif", false));
	}

	echo debut_droite('', true);

	if ($id_breve) {
			$table = "spip_visites_breves";
			$where = "id_breve=$id_breve";
			  
	} else {
			$table = "spip_visites";
			$table_ref = "spip_referers";
			$where = "";
	}

	$order = "date";

	$where2 = $duree ? "$order > DATE_SUB(".sql_quote(date('Y-m-d H:i:s')).",INTERVAL $duree $type)": '';
	if ($where) $where2 = $where2 ?  "$where2 AND $where" : $where;
	$log = statistiques_collecte_date('visites', "(CEIL(UNIX_TIMESTAMP($order) / $interval) *  $interval)", $table, $where2, $serveur);
	
	if ($log)
	  $res = statistiques_breves_tous($log, $id_breve,   $table, $where, $order, $serveur, $duree, $interval, $total_absolu, $val_popularite, $classement, $liste);
	  
	$mois = statistiques_collecte_date("SUM(visites)",
		"FROM_UNIXTIME(UNIX_TIMESTAMP($order),'%Y-%m')", 
		$table,
		"$order > DATE_SUB(NOW(),INTERVAL 2700 DAY)"
		. ($where ? " AND $where" : ''),
		$serveur);

	if (count($mois)>1)  {
		$res[] = "<br /><span class='verdana1 spip_small'><b>"
			. _T('info_visites_par_mois')
			. "</b></span>"
			. statistiques_par_mois($mois, '');
	}
   echo cadre_stat_breves($res, $table, $id_breve);

	echo fin_gauche(), fin_page();	
}

// bas sur http://doc.spip.org/@aff_statistique_visites_par_visites
// adaptation pour les brves
function aff_statistique_breves_par_visites($serveur='', $id_breve=0) {
	$res = "";
	// Par visites depuis le debut
	$result = sql_select("id_breve, titre, visites", "spip_breves", "statut='publie'", "", "visites DESC", "30",'',$serveur);

	while ($row = sql_fetch($result,$serveur)) {
		$titre = typo(supprime_img($row['titre'],''));
		$l_breve = $row['id_breve'];

		if ($l_breve == $id_breve){
			$res.= "<li><b>$titre</b></li>";
		} else {
			$h = generer_url_ecrire("stats_breves_detail","id_breve=$l_breve");
      $out = "<a href='$h' title='visites : ".$row['visites']."'>$titre</a>";
			$res.= "<li>$out</li>";
		}
	}
 
	if (!$res) return '';

	return "<br /><div class='iconeoff' style='padding: 5px;'>"
	  . "<div style='overflow:hidden;' class='verdana1 spip_x-small'>"
	  . typo(_T('stbrv:breves_les_plus_visites'))
	  . "<ol style='padding-left:40px; font-size:x-small;color:#666666;'>"
	  . $res
	  . '</ol></div></div>';
}

// bas sur http://doc.spip.org/@statistiques_tous
// adaptation pour les brves
function statistiques_breves_tous($log, $id_breve, $table, $where, $order, $serveur, $duree, $interval, $total, $liste='', $classement=array(), $script='')
{
	$r = array_keys($log);
	$date_fin = max($r);
	$date_debut = min($r);
	$date_premier = sql_getfetsel("UNIX_TIMESTAMP($order) AS d", $table, $where, '', $order, 1,'',$serveur);
	$last = (time()-$date_fin>$interval) ? 0 : $log[$date_fin];
	$max = max($log);
	$maxgraph = maxgraph($max);
	$rapport = 200 / $maxgraph;
	$agreg = ceil(count($log) / 420);
	$x = ceil(($date_fin-$date_debut)/$interval);
	$largeur = ($agreg > 1) ? 1 : (!$x ? 420 :  floor(420 / $x));

	if ($largeur > 50) $largeur = 50; elseif ($largeur < 1) $largeur = 1;

	list($moyenne, $prec, $res) = stat_log1($log, $agreg, $date_fin, $largeur, $rapport, $interval, $script);

	$stats = "\n<table cellpadding='0' cellspacing='0' border='0'><tr>" .
	  "\n<td ".http_style_background("fond-stats.gif").">"
	. "\n<table cellpadding='0' cellspacing='0' border='0' class='bottom'><tr>"
	. "\n<td style='background-color: black'>" . http_img_rien(1, 200) . "</td>"
	. $res
	   . (!$liste ? '' : // prevision que pour les visites
	      statistiques_prevision($id_breve, $largeur, $moyenne, $rapport, $popularite, $last))
	. "\n<td style='background-color: black'>"
	. http_img_rien(1, 1) ."</td>"
	. "</tr></table>"
	. "</td>\n<td "
	. http_style_background("fond-stats.gif")."  valign='bottom'>"
	. http_img_rien(3, 1, 'trait_bas') ."</td>"
	. "\n<td>" . http_img_rien(5, 1) ."</td>"
	. "\n<td valign='top'>"
	. statistiques_echelle($maxgraph)
	. "</td>"
	. "</tr></table>";

	$total = "<b>" .  _T('info_total') ." " . $total."</b>";

	if  ($liste) {
		$liste = statistiques_classement($id_breve, $classement, $liste);
		$legend = statistiques_nom_des_mois($date_debut, $date_fin, $largeur, $interval, $agreg)
		  . "<span class='arial1 spip_x-small'>"
		  . _T('texte_statistiques_visites')
		  . "</span><br />";
		$resume =  statistiques_resume($max, $moyenne, $last, $prec, $popularite);
	} else {
	  $legend = "<table width='100%'><tr><td width='50%'>" .
	    affdate_heure(date("Y-m-d H:i:s", $date_debut)) .
	    "</td><td width='50%' align='right'>" .
	    affdate_heure(date("Y-m-d H:i:s", $date_fin)) .
	    '</td></tr></table>';
	  $resume = '';
	}

	$legend .=
	  "<table cellpadding='0' cellspacing='0' border='0' width='100%'><tr style='width:100%;'>"
	. $resume
	. "\n<td valign='top' style='width: 33%; ' class='verdana1'>"
	. $total
	. $liste
	. "</td></tr></table>";

	$x = (!$duree) ? 1 : (420/ $duree);
	$zoom = statistiques_breves_zoom($id_breve, $x, $date_premier, $date_debut, $date_fin);
	return array($zoom, $stats, $mark, $legend);
}

// bas sur http://doc.spip.org/@statistiques_zoom
// adaptation pour les brves
function statistiques_breves_zoom($id_breve, $largeur_abs, $date_premier, $date_debut, $date_fin)
{
	if ($largeur_abs > 1) {
		$inc = ceil($largeur_abs / 5);
		$duree_plus = 420 / ($largeur_abs - $inc);
		$duree_moins = 420 / ($largeur_abs + $inc);
	}

	if ($largeur_abs == 1) {
		$duree_plus = 840;
		$duree_moins = 210;
	}

	if ($largeur_abs < 1) {
		$duree_plus = 420 * ((1/$largeur_abs) + 1);
		$duree_moins = 420 * ((1/$largeur_abs) - 1);
	}

	$pour_breve = $id_breve ? "&id_breve=$id_breve" : '';

	$zoom = '';

	if ($date_premier < $date_debut)
		$zoom= http_href(generer_url_ecrire("stats_breves_detail","duree=$duree_plus$pour_breve"),
			 http_img_pack('loupe-moins.gif',
				       _T('info_zoom'). '-',
				       "style='border: 0px; vertical-align: middle;'"),
			 "&nbsp;");
	if ( (($date_fin - $date_debut) / (24*3600)) > 30)
		$zoom .= http_href(generer_url_ecrire("stats_breves_detail","duree=$duree_moins$pour_breve"),
			 http_img_pack('loupe-plus.gif',
				       _T('info_zoom'). '+',
				       "style='border: 0px; vertical-align: middle;'"),
			 "&nbsp;");

	return $zoom;
}

// bas sur http://doc.spip.org/@cadre_stat
// adaptation pour les brves
function cadre_stat_breves($stats, $table, $id_breve)
{
	if (!$stats) return '';
	return debut_cadre_relief("statistiques-24.gif", true)
	. join('', $stats)
	. fin_cadre_relief(true);
	// . statistiques_mode($table, $id_breve);
}

?>
