<?php
/***************************************************************************\
 *  Plugin Statistiques pour les brèves                          	      	 *
 *  Copyright (c) 2007-2009                                                *
 *  Elrik - Peetdu - Mathieu Carrandié                                     *
 *                                                                         *
 *  Basé sur ecrire/genie/visites.php et adapté pour les brèves            *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;
@define('_CRON_LOT_FICHIERS_VISITE_BREVES',100);

// prendre en compte un fichier de visite
// http://doc.spip.org/@compte_fichier_visite
function compte_fichier_visite_breves($fichier, &$visites, &$visites_b) {

	// Noter la visite du site (breve 0)
  $visites ++;

	$content = array();
	if (lire_fichier($fichier, $content))
		$content = @unserialize($content);
	if (!is_array($content)) return;

	foreach ($content as $source => $num) {
		list($log_type, $log_id_num, $log_referer)
			= preg_split(",\t,", $source, 3);
		
		// S'il s'agit d'une brève, noter ses visites
		if ($log_type == 'breve' AND $id_breve = intval($log_id_num)) {
			$visites_b[$id_breve] ++;
		}
	}
}

function calculer_visites_breves($t) {
	include_spip('base/abstract_sql');

	// Initialisations
	$visites = array(); # visites du site
	$visites_b = array(); // tableau des visites des breves
	// $breves = array(); // liste des breves
  
	// charger un certain nombre de fichiers de visites,
	// et faire les calculs correspondant
  
	// Traiter jusqu'a 100 sessions datant d'au moins 30 minutes
	$sessions = preg_files(sous_repertoire(_DIR_TMP, 'visites'));

	$compteur = _CRON_LOT_FICHIERS_VISITE_BREVES;
  $date_init = time()-30*60;
	// $date_init = time()-10;
	foreach ($sessions as $item) {
		if (($d=@filemtime($item)) < $date_init) {
			if (!$d) $d = $date_init; // si le fs ne donne pas de date, on prend celle du traitement, mais tout cela risque d'etre bien douteux
			$d = date("Y-m-d",$d);
			spip_log("BREVES : Traite la session $item", "stats_breves");
			compte_fichier_visite_breves($item, 
        $visites[$d], $visites_b[$d]);
			//spip_unlink($item);
      // On ne detruit pas le fichier car il est utilise par 
      // d'autres compteurs comme visites du site ou visites breves.
      if (--$compteur <= 0)
				break;
		}
		#else spip_log("$item pas vieux");
	}
	if (!count($visites))
		return;

	// Maintenant on dispose de plusieurs tableaux qu'il faut ventiler dans
	// les tables spip_breves, spip_visites_breves ;
  // attention a affecter tout ca a la bonne
	// date (celle de la visite, pas celle du traitement)
	foreach(array_keys($visites) as $date)
		if ($visites[$date]) {

      // 2. les visites des brèves
			if ($visites_b[$date]) {
				$ar = array();	// tableau num -> liste des brèves ayant num visites
				foreach($visites_b[$date] as $id_breve => $n) {
					if (!sql_countsel('spip_visites_breves', 
            "id_breve=$id_breve AND date='$date'")){
						sql_insertq('spip_visites_breves', 
              array('id_breve' => $id_breve, 
                    'visites' => 0, 
                    'date' => $date));
					}
					$ar[$n][] = $id_breve;
				}
				foreach ($ar as $n => $liste) {
					$tous = sql_in('id_breve', $liste);
					sql_update('spip_visites_breves', 
            array('visites' => "visites+$n"), 
              "date='$date' AND $tous");
                
          sql_update('spip_breves', 
            array('visites' => "visites+$n", 
              'maj' => 'maj'), 
              sql_in('id_breve', $liste));
				}
		  }
    }
	// S'il reste des fichiers a manger, le signaler pour reexecution rapide
	if ($compteur==0) {
		spip_log("il reste des visites a traiter...");
		return -$t;
	}
}

//
// Calcule les stats en plusieurs etapes
//
function genie_stats_breves_cron($t) {
	spip_log("BREVES : **** CRON : CALCUL VISITES BREVES **** ", "stats_breves");
	if ($GLOBALS['meta']['activer_statistiques'] == 'oui' and $GLOBALS['meta']['activer_breves'] == 'oui') {
		$encore = calculer_visites_breves($t);
    
		// Si ce n'est pas fini on redonne la meme date au fichier .lock
		// pour etre prioritaire lors du cron suivant
    if ($encore)
      return (0 - $t);		
	}
	return 1;
}

?>